/******************************************************************************
*  Nano-RK, a real-time operating system for sensor networks.
*  Copyright (C) 2007, Real-Time and Multimedia Lab, Carnegie Mellon University
*  All rights reserved.
*
*  This is the Open Source Version of Nano-RK included as part of a Dual
*  Licensing Model. If you are unsure which license to use please refer to:
*  http://www.nanork.org/nano-RK/wiki/Licensing
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, version 2.0 of the License.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*  Contributing Authors (specific to this file):
*  Aditya Bhave
*******************************************************************************/


#ifndef _DEBUG_H
#define _DEBUG_H

/********************************** FUNCTION PROTOTYPES *******************************/
void go_into_panic(char *str);
/*
This function is used for debugging purposes. It sets the red LED on the nodes and keeps 
printing an error message forever

	PARAMS:		str:	The string to be printed
	RETURNS:		None
	COMMENTS:	debugging utility
*/ 

void print_nw_stack_errno(int8_t n);
/*
This helper function prints a descriptive message corresponding to a given error number

	PARAMS:		n: the error number
	RETURNS:		None
	Comments:	User API
*/

#endif 

