/******************************************************************************
*  Nano-RK, a real-time operating system for sensor networks.
*  Copyright (C) 2007, Real-Time and Multimedia Lab, Carnegie Mellon University
*  All rights reserved.
*
*  This is the Open Source Version of Nano-RK included as part of a Dual
*  Licensing Model. If you are unsure which license to use please refer to:
*  http://www.nanork.org/nano-RK/wiki/Licensing
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, version 2.0 of the License.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*  Contributing Authors (specific to this file):
*  Aditya Bhave
*******************************************************************************/


/*
This file contains a list of the error codes set by the various functions of the network stack
*/

#ifndef _NW_ERROR_CODES_H
#define _NW_ERROR_CODES_H

#define MAX_NEIGHBOR_LIMIT_REACHED 1
#define NO_SOCKET_DESC_AVAILABLE 2
#define UNSUPPORTED_SOCK_TYPE 3 
#define PORT_UNAVAILABLE 4   
#define INVALID_SOCKET 5   
#define INVALID_CALL 6  
#define NO_PORTS_AVAILABLE 7
#define INVALID_ARGUMENT 8  
#define ERROR_ENDIAN 9 
#define NO_RX_BUFFERS_AVAILABLE 10
#define NO_TX_BUFFERS_AVAILABLE 11 
#define SOCKET_TIMEOUT 12 
#define UNMAPPED_SOCKET 13
#define NO_PORT_ELEMENT_AVAILABLE 14
#define NO_RBM_ELEMENT_AVAILABLE 15

#endif 
